#!/usr/bin/php
<?php

/********************************************************************************
 * @Script		:	Importa Berkeley(Jabberd2) para Mysql(Jabberd2)
 * @Author(s)	:	Alexandre Correia
 * 					Rodrigo Souza 
 * @Date		:	09/04/2009
 ********************************************************************************/

include("ado/adodb.inc.php");
require_once("config.php");

class exportDb
{
	private $DB;
	private $SERVER;
	private $USERDB;
	private $PASSWORD_DB;
	private $BASEDB;
	
	
	function __construct()
	{
		$this->SERVER		= JABBERD2_SERVER;
		$this->USERDB		= JABBERD2_USERDB;
		$this->PASSWORDB	= JABBERD2_PASSWORDB;
		$this->BASEDB		= JABBERD2_BASEDB;
		$this->connectDB();		
	}
	
	function __destruct()
	{
		$this->DB->disconnect();		
	}
	
	private function connectDB()
	{
		$this->DB = NewADOConnection("mysql");
		$this->DB->Connect($this->SERVER, $this->USERDB, $this->PASSWORDB, $this->BASEDB);
	}		

	private function search_jid_name_to_from_ask($pString)
	{
		$string = trim($pString);
		preg_match('/ask\\\00\\\01\\\00\\\00\\\00\\\/', $string, $matches_ask, PREG_OFFSET_CAPTURE );
		preg_match('/\\\00from/', $string, $matches_from, PREG_OFFSET_CAPTURE );
		preg_match('/\\\00to/', $string, $matches_to, PREG_OFFSET_CAPTURE );
		preg_match('/\\\00name/', $string, $matches_name, PREG_OFFSET_CAPTURE );
		preg_match('/\\\00jid/', $string, $matches_jid, PREG_OFFSET_CAPTURE );					
		
		$ask  = @substr($string, ($matches_ask[0][1] + 20 ), 1);
		$from = @substr($string, ($matches_from[0][1] + 24 ), 1);
		$to   = @substr($string, ($matches_to[0][1] + 22 ), 1);

		if( @$matches_name[0][1] )
		{	
			$name = @substr($string, ($matches_name[0][1] + 22 ), $matches_jid[0][1]);
			preg_match('/\\\00jid/', $name, $matches_jid_, PREG_OFFSET_CAPTURE );
			$name = @substr($name, 0, $matches_jid_[0][1]);
		}else
			$name = "";
							
		$jid = @substr($string, $matches_jid[0][1], strlen($string) - 3);
		$jid = @substr($jid, 21 );
		$jid = @substr($jid, 0 , strlen($jid) - 3); 
		
		return "'".$jid."','".addslashes($name)."','".$to."','".$from."','".$ask."');";
	}

	private function _readFile($pFile)
	{
		$file = fopen($pFile, "r");
		$content = array();
		
		while(!feof($file))
		{
			$aux = fgets($file, 4096);
			if(trim($aux != "") )
				$content[] = $aux;
		}
		
		fclose($file);
		
		// Retira o Ultimo elemento => DATA=END		
		array_pop($content);
		
		// Retira os 7 primeiros elementos
		$content = array_slice($content,7);
		
		return $content;	
	}

	private function queryDb($pQuery)
	{
		$result = $this->DB->Execute($pQuery);

		if( !$result )						
			return false;
		else
			return true;	
	}

	private function _writeFile($pString)
	{

		$filename = dirname(__FILE__).'/ERROR.log';
		$caracter = "$";
		$content = $pString;

		if (!$handle = fopen($filename, 'w'))
		{
			echo "No foi possvel abrir o arquivo : \n($filename)";
		}
		
		if (fwrite($handle, $content) === FALSE)
		{
			echo "No foi possvel escrever no arquivo : \n($filename)";
		}
		
		fclose($handle);
	}
	
	public function active_Jabberd($pFile)
	{
		$i = 0;
		$query = array();
		$return = $this->_readFile($pFile);
		
		foreach($return as $tmp)
		{
			preg_match('/time/', $tmp, $matches );
			if( count($matches) > 0 )
			{	
				$_time = explode('time\00\01\00\00\00', $tmp);
				$query[$i++] = $query[($i-1)] . "'" . hexdec($_time[1]). "');";
			}
			else
				$query[$i] = "INSERT INTO active(`collection-owner`,time) values('".trim($tmp)."',";
		}
		
		foreach($query as $qtmp)
			if(!($this->queryDb($qtmp)))
				$this->_writeFile("Jabberd2 - ERRO base active: " . $qtmp . "\n");
	}


	public function logout_Jabberd($pFile)
	{
		$i = 0;
		$query = array();
		$return = $this->_readFile($pFile);
		
		foreach($return as $tmp)
		{
			preg_match('/time/', $tmp, $matches );
			if( count($matches) > 0 )
			{	
				$_time = explode('time\00\01\00\00\00', $tmp);
				$query[$i++] = $query[($i-1)] . "'" . hexdec($_time[1]). "');";
			}
			else
				$query[$i] = "INSERT INTO logout(`collection-owner`,time) values('".trim($tmp)."',";
		}
		
		foreach($query as $qtmp)
			if(!($this->queryDb($qtmp)))
				$this->_writeFile("Jabberd2 - ERRO base logout: " . $qtmp . "\n");
	}
	
	public function privacy_default_Jabberd($pFile)
	{
		$i = 0;
		$query = array();
		$return = $this->_readFile($pFile);
		 
		foreach($return as $tmp)
		{
			preg_match('/default/', $tmp, $matches );
			if( count($matches) > 0 )
			{	
				$string = explode('default\00\02\00\00\00', $tmp);
				$query[$i++] = $query[($i-1)] . "'" . trim($string[1]). "');";
			}
			else
				$query[$i] = "INSERT INTO `privacy-default`(`collection-owner`,`default`) values('".trim($tmp)."',";
		}
		
		foreach($query as $qtmp)
			if(!($this->queryDb($qtmp)))
				$this->_writeFile("Jabberd2 - ERRO base privacy-default : " . $qtmp . "\n");
	}
	
	public function private_Jabberd($pFile)
	{
		$i = 0;
		$query = array();
		$return = $this->_readFile($pFile);
		 
		foreach($return as $tmp)
		{
			preg_match('/xml/', $tmp, $matches );
			if( count($matches) > 0 )
			{
				$string = trim($tmp);
				preg_match('/\\\00ns\\\00\\\02\\\00\\\00\\\00/', $string, $matches_ns, PREG_OFFSET_CAPTURE );

				$ns = @substr($string, ($matches_ns[0][1] + 20));
				$ns = @substr($ns,0, strlen($ns) - 3 );
				
				$xml = @substr($string, 0, $matches_ns[0][1]);
				$xml = @substr($xml,18 );
				
				$query[$i++] = $query[($i-1)] . "'".$ns."','".addslashes($xml)."');";
			}
			else
				$query[$i] = "INSERT INTO private(`collection-owner`,`ns`,`xml`) value('".trim($tmp)."',";
		}

		$j = 0;
		
		foreach($query as $qtmp)
		{
			if(!($this->queryDb($qtmp)) )
				$this->_writeFile("Jabberd2 - ERRO base private: " . $qtmp . "\n");
			$j++;
		}
	}
	
	public function queue_Jabberd($pFile)
	{
		$i = 0;
		$query = array();
		$return = $this->_readFile($pFile);
		 
		foreach($return as $tmp)
		{
			preg_match('/xml\\\00\\\03\\\00\\\00\\\00/', $tmp, $matches );			
			if( count($matches) > 0 )
			{
				$string = trim($tmp);
				$string = @substr($string,18);
				$string = @substr($string,0, strlen($string) - 3);

				$query[$i++] = $query[($i-1)] . "'". addslashes($string)."');";
			}
			else
				$query[$i] = "INSERT INTO queue(`collection-owner`,`xml`) value('".trim($tmp)."',";
		}
		
		foreach($query as $qtmp)
			if(!($this->queryDb($qtmp)))
				$this->_writeFile("Jabberd2 - ERRO base queue : " . $qtmp . "\n");
	}
	
	public function roster_groups_Jabberd($pFile)
	{
		$i = 0;
		$query = array();
		$return = $this->_readFile($pFile);
		 
		foreach($return as $tmp)
		{
			preg_match('/group/', $tmp, $matches );
			if( count($matches) > 0 )
			{
				$string = trim($tmp);						
				
				preg_match('/\\\00jid\\\00\\\02\\\00\\\00\\\00/', $string, $matches_jid, PREG_OFFSET_CAPTURE );
				
				$jid = @substr($string, ($matches_jid[0][1] + 21));
				$jid = @substr($jid,0, strlen($jid) -3 );

				$group = @substr($string, 0, $matches_jid[0][1]);
				$group = @substr($group,20);
				
				$query[$i++] = $query[($i-1)] . "'".$jid."','".addslashes($group)."');";
			}
			else
			{
				$query[$i] = "INSERT INTO `roster-groups`(`collection-owner`,`jid`,`group`) value('".trim($tmp)."',";
			}
		}
		
		foreach($query as $qtmp)
			if(!($this->queryDb($qtmp)))
				$this->_writeFile("Jabberd2 - ERRO roster-groups : " . $qtmp . "\n");
	}

	public function roster_items_Jabberd($pFile)
	{
		$i = 0;
		$query	= array();
		$return = array();
		 
		$return = $this->_readFile($pFile);
		 
		foreach($return as $tmp)
		{
			preg_match('/ask/', $tmp, $matches);
			
			if( count($matches) > 0 )
			{
				$query[$i++] = $query[($i-1)] .$this->search_jid_name_to_from_ask($tmp);
			}
			else
				$query[$i] = "INSERT INTO `roster-items`(`collection-owner`,`jid`,`name`,`to`,`from`,`ask`) value('".trim($tmp)."',";
		}
		
		foreach($query as $qtmp)
		{
			preg_match('/^INSERT/', $qtmp, $matches_sql);
			
			if( count($matches_sql) > 0 )
				if(!($this->queryDb($qtmp)))
					$this->_writeFile("Jabberd2 - ERRO base roster-items : " . $qtmp . "\n");

			usleep(1000);
		}
			
	}
	
	public function status($pFile)
	{
		$i = 0;
		$query = array();
		$return = $this->_readFile($pFile);
		
		foreach($return as $tmp)
		{
			preg_match('/status\\\00\\\02\\\00\\\00\\\00/', $tmp, $matches );
			
			if( count($matches) > 0 )
			{
				$string = trim($tmp);
				
				preg_match('/status\\\00\\\02\\\00\\\00\\\00/', $string, $matches_status, PREG_OFFSET_CAPTURE );
				preg_match('/\\\00show\\\00\\\02\\\00\\\00\\\00/', $string, $matches_show, PREG_OFFSET_CAPTURE );
				preg_match('/\\\00last-login\\\00\\\01\\\00\\\00\\\00/', $string, $matches_last_login, PREG_OFFSET_CAPTURE );
				preg_match('/xml\\\00\\\03\\\00\\\00\\\00/', $string, $matches_xml, PREG_OFFSET_CAPTURE );
				preg_match('/last-logout\\\00\\\01\\\00\\\00\\\00/', $string, $matches_last_logout, PREG_OFFSET_CAPTURE );

				$status		= @substr($string, ( $matches_status[0][1] +21 ), $matches_show[0][1] );
				$status		= @substr($status, 0, strlen($status) -21); 

				$show		= @substr($string, ($matches_show[0][1] + 22 ), $matches_last_login[0][1]);
				preg_match('/\\\00last-login/', $show, $matches_show_, PREG_OFFSET_CAPTURE );
				$show		= @substr($show, 0, $matches_show_[0][1]);
				
				$last_login	= @substr($string, ($matches_last_login[0][1] + 29 ), $matches_xml[0][1]);
				preg_match('/xml\\\00\\\03\\\/', $last_login, $matches_last_login_, PREG_OFFSET_CAPTURE );
				$last_login = hexdec(@substr($last_login, 0, $matches_last_login_[0][1]));
				
				$xml	= @substr($string, ($matches_xml[0][1] + 18 ), $matches_last_logout[0][1]);
				preg_match('/\\\00last-logout\\\/', $xml, $matches_xml_, PREG_OFFSET_CAPTURE );
				$xml	= @substr($xml, 0, $matches_xml_[0][1]); 
				
				$last_logout = hexdec(@substr($string, ($matches_last_logout[0][1]) + 27 ));
				
				$query[$i++] = $query[($i -1)] . "'".$status."'," . "'".$show."'," . "'".$last_login."'," . "'".addslashes($xml)."',"."'".$last_logout."');";
				
			}else
				$query[$i] = "INSERT INTO status(`collection-owner`, `status`, `show`, `last-login`, `last-logout`, `xml`) value('".trim($tmp)."',";
		}
		
		foreach($query as $qtmp)
			if(!($this->queryDb($qtmp)))
				$this->_writeFile("Jabberd2 - ERRO base status : " . $qtmp . "\n");
	}
	
	public function totalExport($pBase)
	{
		$result = $this->DB->Execute("SELECT * FROM `".$pBase."`;");
		return $result->PO_RecordCount($pBase);
	}
}

	/**
	 **** Bancos a serem exportados **** 
	 * active.dump 				= S - ok
	 * disco-items.dump 			= N	- SEM REGISTRO 
	 * logout.dump				= S - ok
	 * motd-message.dump			= N - SEM REGISTRO
	 * privacy-default.dump		= S	- ok  
	 * privacy-items.dump		= S - SEM IMPORTAR
	 * private.dump				= S	- ok
	 * queue.dump				= S - ok
	 * roster-groups.dump		= S - ok
	 * roster-items.dump			= S - ok
	 * status.dump				= S	- ok
	 * vacation-settings.dump	= N - SEM REGISTRO
	 * vcard.dump				= N - no ser importado
	 */


	$obj = new exportDB();

	echo "\n********* INICIO DA IMPORTACAO ********\n\n";
	
	//get active.dump
	echo "IMPORTANDO - active.dump \n\n";
	$obj->active_Jabberd('dump_db/active.dump');
	
	//get logout.dump
	echo "IMPORTANDO - logout.dump \n\n";
	$obj->logout_Jabberd('dump_db/logout.dump');
	
	// get privacy-default.dump
	echo "IMPORTANDO - privacy-default.dump \n\n";
	$obj->privacy_default_Jabberd('dump_db/privacy-default.dump');
	
	// get private.dump
	echo "IMPORTANDO - private.dump \n\n";
	$obj->private_Jabberd('dump_db/private.dump');
	
	// get queue.dump
	echo "IMPORTANDO - queue.dump \n\n";
	$obj->queue_Jabberd('dump_db/queue.dump');
	
	// get roster-groups.dump
	echo "IMPORTANDO - roster-groups.dump \n\n";
	$obj->roster_groups_Jabberd('dump_db/roster-groups.dump');
	
	// get roster-items.dump
	echo "IMPORTANDO - roster-items.dump \n\n";
	$obj->roster_items_Jabberd('dump_db/roster-items.dump');
	
	// get status.dump
	echo "IMPORTANDO - status.dump \n\n";
	$obj->status('dump_db/status.dump');

	echo "***** Total Reg. Exportados *****\n\n";
	$nameBase = array("active","logout","privacy-default","private","queue","roster-groups","roster-items","status");

	foreach($nameBase as $Btmp)
		echo "Base " . $Btmp . " : ". $obj->totalExport($Btmp) . " registros \n";
	
	echo "\nVerifique o arquivo " .dirname(__FILE__) . "/ERROR.log \n";
	
	echo "\n********* FIM DA IMPORTACAO ********\n\n";

?>
