#!/usr/bin/php
<?php

/********************************************************************************
 * @Script		:	Mysql(Jabberd2) para Mysql(Ejabberd)
 * @Author(s)	:	Alexandre Correia
 * 					Rodrigo Souza 
 * @Date		:	15/04/2009
 ********************************************************************************/

include("ado/adodb.inc.php");
require_once("config.php");

class jb2ej
{
	private $DB;
	private $SERVER;
	private $USERDB;
	private $PASSWORD_DB;
	private $BASEDB;
	
	function __construct()
	{
		$this->SERVER		= JABBERD2_SERVER;
		$this->USERDB		= JABBERD2_USERDB;
		$this->PASSWORDB	= JABBERD2_PASSWORDB;
		$this->BASEDB		= JABBERD2_BASEDB;
		$this->connectDB();		
	}
	
	function __destruct()
	{
		$this->DB->disconnect();		
	}
	
	private function connectDB()
	{
		$this->DB = NewADOConnection("mysql");
		$this->DB->Connect($this->SERVER, $this->USERDB, $this->PASSWORDB, $this->BASEDB);
	}		

	private function connectDBEJ($pQuery)
	{
		
		$DB = NewADOConnection("mysql");
		$DB->Connect( EJABBERD_SERVER, EJABBERD_USERDB, EJABBERD_PASSWORD, EJABBERD_BASEDB );
		
		$result = $DB->Execute($pQuery);
		$DB->disconnect();
				
		if( !$result )
			return false;
		else
			return true;
	}
	
	private function _writeFile($pString)
	{

		$filename = dirname(__FILE__).'/ERROR.log';
		$caracter = "$";
		$content = $pString;

		if (!$handle = fopen($filename, 'w'))
		{
			echo "No foi possvel abrir o arquivo : \n($filename)";
		}
		
		if (fwrite($handle, $content) === FALSE)
		{
			echo "No foi possvel escrever no arquivo : \n($filename)";
		}
		
		fclose($handle);
	}
	
	public function activeJb_to_lastEj()
	{
		$query = "SELECT `collection-owner`, `time` FROM active;";
		
		$i = 0;
		$this->DB->SetFetchMode(ADODB_FETCH_ASSOC); //retorna array associativo
		$result = $this->DB->Execute($query);
		$sQuery = array();
		
		if( !$result )
			return false;

		while ($row = $result->FetchNextObject())
		{
			  $sQuery[$i++] = "INSERT INTO last(username,seconds) value('".substr($row->{'COLLECTION-OWNER'}, 0, strpos($row->{'COLLECTION-OWNER'},"@"))."','".$row->TIME."');"; 
		}
		
		foreach($sQuery as $qtmp)
		{
			if(!($this->connectDBEJ($qtmp)))
				$this->_writeFile("Ejabberd - ERRO base last: " . $qtmp . "\n");
		}
	}
	
	public function privateJb_to_privateStorageEj()
	{
		$query = "SELECT `collection-owner`, `ns`, `xml` FROM private;";

		$i = 0;
		$this->DB->SetFetchMode(ADODB_FETCH_ASSOC); //retorna array associativo
		$result = $this->DB->Execute($query);
		$sQuery = array();

		if( !$result )
			return false;
		
		while($row = $result->FetchNextObject())
		{

			$xml = $row->{'XML'};
			
			if( $row->{'NS'} === 'j2m:prefs' )
			{
				$xml = substr($xml,strpos($xml,"<j2m"));
				$xml = substr($xml, 0, strpos($xml,"</j2m>") + 6);
			}
			else
			{
				$xml = substr($xml, strpos($xml, "jabber:iq:private") + 19 );
				$xml = substr($xml, 0, strpos($xml, "</query>"));
			}
				
			
			$sQuery[$i++] = "INSERT INTO private_storage(username, namespace, data) value(" .
							"'".substr($row->{'COLLECTION-OWNER'}, 0, strpos($row->{'COLLECTION-OWNER'},"@"))."','".$row->{'NS'}."','".addslashes(utf8_decode($xml))."');";
		}
		
		foreach($sQuery as $qtmp)
		{
			if(!($this->connectDBEJ($qtmp)))
				$this->_writeFile("Ejabberd - ERRO base private_storage: " . $qtmp . "\n");
		}
	}
	
	public function rostergroupsJb_to_rostergroupsEj()
	{
		$query = "SELECT `collection-owner`, `jid`, `group` FROM `roster-groups`;";

		$i = 0;
		$this->DB->SetFetchMode(ADODB_FETCH_ASSOC); //retorna array associativo
		$result = $this->DB->Execute($query);
		$sQuery = array();
		
		if( !$result )
			return false;
			
		while($row = $result->FetchNextObject())
		{
			$sQuery[$i++] = "INSERT INTO rostergroups(username, jid, grp) value(" .
							"'".substr($row->{'COLLECTION-OWNER'}, 0, strpos($row->{'COLLECTION-OWNER'},"@"))."','".$row->{'JID'}."','".addslashes($row->{'GROUP'})."');";	
		}

		foreach($sQuery as $qtmp)
		{
			if(!($this->connectDBEJ($qtmp)))
				$this->_writeFile("Ejabberd - ERRO base rostergroups: " . $qtmp . "\n");
		}
	}

	public function rosteritemsJb_to_rosterusersEj()
	{
		$query = "SELECT `collection-owner`,`jid`, `name`, `to`, `from`, `ask` FROM `roster-items`;";

		$i = 0;
		$this->DB->SetFetchMode(ADODB_FETCH_ASSOC); //retorna array associativo
		$result = $this->DB->Execute($query);
		$sQuery = array();
		
		if( !$result )
			return false;

		while($row = $result->FetchNextObject())
		{
			
			if( $row->{'TO'} == 0 && $row->{'FROM'} == 1 )
				$string = "'F','O','N','item'";

			if( $row->{'TO'} == 1 && $row->{'FROM'} == 1 )
				$string = "'B','N','N','item'";
				
			if( $row->{'TO'} == 1 && $row->{'FROM'} == 0 )
				$string = "'T','I','N','item'";

			$sQuery[$i++] = "INSERT INTO rosterusers(username, jid, nick, subscription, ask, server, type) value(".
							"'".substr($row->{'COLLECTION-OWNER'}, 0, strpos($row->{'COLLECTION-OWNER'},"@"))."','".$row->{'JID'}."','".addslashes($row->{'NAME'})."',".$string.");";
		}
		
		foreach($sQuery as $qtmp)
		{
			if(!($this->connectDBEJ($qtmp)))
				$this->_writeFile("Ejabberd - ERRO base rosterusers: " . $qtmp . "\n");
		}
			
	}

	public function queueJb_to_spoolEj()
	{
		$query = "SELECT `collection-owner`, `xml` FROM queue;";

		$i = 0;
		$this->DB->SetFetchMode(ADODB_FETCH_ASSOC); //retorna array associativo
		$result = $this->DB->Execute($query);
		$sQuery = array();
		
		if( !$result )
			return false;
			
		while($row = $result->FetchNextObject())
		{
			$xml = str_replace("<route xmlns='http://jabberd.jabberstudio.org/ns/component/1.0' from='".SERVER_JABBER."' to='".SERVER_JABBER."'>","",$row->{'XML'});
			$xml = str_replace("</route>","",$xml);

			$sQuery[$i++] = "INSERT INTO spool(username, xml) value(" .
							"'".substr($row->{'COLLECTION-OWNER'}, 0, strpos($row->{'COLLECTION-OWNER'},"@"))."','".addslashes(utf8_decode($xml))."');";
		}
		
		foreach($sQuery as $qtmp)
		{
			if(!($this->connectDBEJ($qtmp)))
				$this->_writeFile("Ejabberd - ERRO base spool: " . $qtmp . "\n");
		}
	}
}

	echo "\n********* INICIO DA IMPORTACAO ********\n\n";

	// jabberd2-active to ejabberd-last;
	$obj = new jb2ej();
	echo "jabberd2-active to ejabberd-last \n\n";
	$obj->activeJb_to_lastEj();
	unset($obj);
	

	// jabberd2-private to ejabberd private_storage;
	$obj = new jb2ej();
	echo "jabberd2-private to ejabberd private_storage \n\n";
	$obj->privateJb_to_privateStorageEj();
	unset($obj);
	
	// jabberd2-roster-groups to ejabberd rostergroups;
	$obj = new jb2ej();
	echo "jabberd2-roster-groups to ejabberd rostergroups \n\n";
	$obj->rostergroupsJb_to_rostergroupsEj();
	unset($obj);	

	// jabberd2-roster-items to ejabberd rosterusers
	$obj = new jb2ej();
	echo "jabberd2-roster-items to ejabberd rosterusers \n\n";
	$obj->rosteritemsJb_to_rosterusersEj();
	unset($obj);
	
	// jabberd2-queue to ejabberd-spool;
	$obj = new jb2ej();
	echo "jabberd2-queue to ejabberd-spool \n\n";
	$obj->queueJb_to_spoolEj();
	unset($obj);

	echo "\nVerifique o arquivo " .dirname(__FILE__) . "/ERROR.log \n";

	echo "\n********* FIM DA IMPORTACAO ********\n\n";
	
?>
